<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/AccessoryBaseLight.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('AccessoryBaseLight_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">AccessoryBaseLight.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**********************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Class for a light, flashing or not, with optional fading&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">***********************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;AccessoryBaseLight.hpp&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;EEPROM.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#ifndef NO_LIGHT</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classAccessoryBaseLight.html#a88e2be8a90a47be58d0283ed8c6c973d">   15</a></span>&#160;<a class="code" href="classAccessoryBaseLight.html#a88e2be8a90a47be58d0283ed8c6c973d">AccessoryBaseLight::AccessoryBaseLight</a>(<a class="code" href="classAccessory.html">Accessory</a> *inpOwner)</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    this-&gt;pPort = NULL;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    this-&gt;state = LIGHTOFF;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    this-&gt;currentState = LIGHT_OFF;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    this-&gt;startingMillis = 0;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    this-&gt;fadingStep = this-&gt;fadingDelay = 0;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    this-&gt;blinkingDelay = 0;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    this-&gt;pOwner = inpOwner;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;}</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::SetState(ACC_STATE inState)</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;{ </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordflow">if</span> (inState == LIGHTBLINK &amp;&amp; this-&gt;blinkingDelay == 0)</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        inState = LIGHTON;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryBaseLight SetState &quot;</span>));</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    Serial.println(inState == LIGHTON ? <span class="stringliteral">&quot;ON&quot;</span> : inState == LIGHTOFF ? <span class="stringliteral">&quot;OFF&quot;</span> : <span class="stringliteral">&quot;BLINK&quot;</span>);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    this-&gt;SetStateRaw(inState);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;}</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::SetStateRaw(ACC_STATE inNewState)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;{</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordflow">if</span> (this-&gt;state != inNewState)</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        this-&gt;state = inNewState;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        this-&gt;pOwner-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(inNewState);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    }</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classAccessoryBaseLight.html#a1e1a200e6f6e47e63d07059c91265a91">   48</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryBaseLight.html#a1e1a200e6f6e47e63d07059c91265a91">AccessoryBaseLight::SetFading</a>(uint8_t inStep, uint8_t inDelay)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;{</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    this-&gt;fadingStep = inStep;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    this-&gt;fadingDelay = inDelay;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    this-&gt;fadingCurrentValue = 0;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordflow">if</span> (this-&gt;pPort-&gt;<a class="code" href="classPort.html#a99e8526fed0e88d9f553767ef30860df">GetPinType</a>() == DIGITAL || this-&gt;pPort-&gt;<a class="code" href="classPort.html#a99e8526fed0e88d9f553767ef30860df">GetPinType</a>() == DIGITAL_INVERTED)</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Fading on a light is not allowed on a DIGITAL pin !&quot;</span>));</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordflow">if</span> (this-&gt;blinkingDelay &gt; 0 &amp;&amp; FADING_FULL_DELAY &gt; this-&gt;blinkingDelay)</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Light fading duration greater than blinking duration !&quot;</span>));</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;}</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classAccessoryBaseLight.html#a26c343fd849b47aea637ef7f34c3270a">   62</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryBaseLight.html#a26c343fd849b47aea637ef7f34c3270a">AccessoryBaseLight::begin</a>(<a class="code" href="classPort.html">Port</a> *inpPort, <span class="keywordtype">int</span> inIntensity, <a class="code" href="classAccessory.html">Accessory</a> *inpOwner)</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;{</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">if</span> (inpOwner != NULL)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        this-&gt;pOwner = inpOwner;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    this-&gt;pPort = inpPort;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inIntensity);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    this-&gt;LightOff();</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::LightFadingRaw(uint8_t inValue)</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;{</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryBaseLight Fading at &quot;</span>));</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    Serial.println(inValue);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    this-&gt;fadingCurrentValue = inValue;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    this-&gt;pPort-&gt;<a class="code" href="classPort.html#aef667cb477268c60f098300e139530ba">MoveLeftDir</a>(-1, inValue);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::LightOnRaw()</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;{</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    this-&gt;LightFadingRaw(this-&gt;pPort-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>());</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;}</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::LightOffRaw()</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;{</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    this-&gt;LightFadingRaw(0);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    this-&gt;pPort-&gt;<a class="code" href="classPort.html#a63cfeea67bec1eab18758d74cd435c00">MoveStop</a>();</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;}</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::LightOn()</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;{</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryBaseLight ON&quot;</span>));</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    this-&gt;SetState(LIGHTON);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;}</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::LightOff()</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;{</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;AccessoryBaseLight OFF&quot;</span>));</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    this-&gt;SetState(LIGHTOFF);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;}</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;ACC_STATE AccessoryBaseLight::Toggle()</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;{</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordflow">if</span> (this-&gt;state == LIGHTON || this-&gt;state == LIGHTBLINK)</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        this-&gt;SetState(LIGHTOFF);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        this-&gt;SetState(LIGHTBLINK); <span class="comment">// will be converted in LIGHTON if Duration is 0 !</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">return</span> this-&gt;state; </div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;}</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classAccessoryBaseLight.html#accc565a1d92ad5f4fb05850f1390791b">  120</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessoryBaseLight.html#accc565a1d92ad5f4fb05850f1390791b">AccessoryBaseLight::Event</a>(ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;{</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">switch</span> (inEvent)</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    {</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITIONID:</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_TOGGLE:</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        this-&gt;Toggle();</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVE:</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keywordflow">switch</span> (inData)</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        {</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STRAIGHT:</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_TOP:</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LEFT:</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_DIVERGE:</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_BOTTOM:</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_RIGHT:</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_ON:</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            this-&gt;LightOn();</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_OFF:</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_STOP:</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            this-&gt;LightOff();</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_MORE:</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keywordflow">case</span> ACCESSORIES_MOVE_LESS:</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            {</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            <span class="keywordtype">int</span> oldValue = this-&gt;pPort-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>();</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(oldValue + inData);</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            this-&gt;LightOn();</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(oldValue);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            }</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        }</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_MOVEPOSITION:</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        {</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            <span class="keywordtype">int</span> oldValue = this-&gt;pPort-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>();</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inData);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            this-&gt;LightOn();</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(oldValue);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        }</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">case</span> ACCESSORIES_EVENT_SETSPEED:</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        this-&gt;pPort-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inData);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keywordflow">default</span>:</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    }</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;}</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::StartAction()</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;{</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keywordflow">if</span> (this-&gt;blinkingDelay &gt; 0 || this-&gt;<a class="code" href="classAccessoryBaseLight.html#aa3b580656c99a87a7e88946f407e712d">IsFading</a>())</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    {</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        this-&gt;startingMillis = millis();</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    }</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;AccessoryBaseLight start action &quot;</span>));</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    Serial.println(this-&gt;startingMillis);</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;}</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="keywordtype">bool</span> AccessoryBaseLight::ActionEnded()</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;{</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="keywordflow">if</span> (this-&gt;pOwner-&gt;<a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>())</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;End action of light.&quot;</span>));</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    this-&gt;pOwner-&gt;<a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keywordflow">if</span> (this-&gt;state == LIGHTON &amp;&amp; this-&gt;currentState == LIGHT_ON)</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keywordflow">if</span> (this-&gt;state == LIGHTOFF &amp;&amp; this-&gt;currentState == LIGHT_OFF)</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Light current state : &quot;</span>));</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keywordflow">switch</span> (this-&gt;currentState)</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    {</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keywordflow">case</span> LIGHT_ON:</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;On&quot;</span>));</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordflow">case</span> LIGHT_OFF:</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Off&quot;</span>));</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keywordflow">case</span> LIGHT_ASCENDING:</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Ascending&quot;</span>));</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordflow">case</span> LIGHT_DESCENDING:</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Descending&quot;</span>));</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordflow">break</span>;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="keywordflow">switch</span> (this-&gt;currentState)</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    {</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keywordflow">case</span> LIGHT_ON:</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            <span class="keywordflow">if</span> (this-&gt;state == LIGHTOFF) </div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            {</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessoryBaseLight.html#aa3b580656c99a87a7e88946f407e712d">IsFading</a>() || (this-&gt;<a class="code" href="classAccessoryBaseLight.html#ac82a7a3b7ab0da4aefd959d03ba0ed4a">IsBlinking</a>() &amp;&amp; millis() - this-&gt;startingMillis &gt; this-&gt;blinkingDelay - FADING_FULL_DELAY))</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                {</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;                    this-&gt;currentState = LIGHT_DESCENDING;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;                    this-&gt;startingMillis = millis();</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                    this-&gt;LightFadingRaw(this-&gt;pPort-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>());</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;                }</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;                this-&gt;currentState = LIGHT_OFF;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;                this-&gt;pPort-&gt;<a class="code" href="classPort.html#a63cfeea67bec1eab18758d74cd435c00">MoveStop</a>();</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            }</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordflow">case</span> LIGHT_OFF:</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="keywordflow">if</span> (this-&gt;state == LIGHTON)</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            {</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessoryBaseLight.html#aa3b580656c99a87a7e88946f407e712d">IsFading</a>() || (this-&gt;<a class="code" href="classAccessoryBaseLight.html#ac82a7a3b7ab0da4aefd959d03ba0ed4a">IsBlinking</a>() &amp;&amp; millis() - this-&gt;startingMillis &gt; this-&gt;blinkingDelay - FADING_FULL_DELAY))</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                {</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                    this-&gt;currentState = LIGHT_ASCENDING;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;                    this-&gt;startingMillis = millis();</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                    this-&gt;LightFadingRaw(0);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                }</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                this-&gt;currentState = LIGHT_ON;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                this-&gt;pPort-&gt;<a class="code" href="classPort.html#aef667cb477268c60f098300e139530ba">MoveLeftDir</a>();</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            }</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        <span class="keywordflow">case</span> LIGHT_ASCENDING:</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        {</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keywordtype">bool</span> endStateAsc = <span class="keyword">false</span>;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            <span class="keywordflow">if</span> (this-&gt;fadingStep == 0)</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                endStateAsc = <span class="keyword">true</span>;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                <span class="keywordflow">if</span> (millis() - this-&gt;startingMillis &gt; this-&gt;fadingDelay)</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                {</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                    <span class="keywordtype">int</span> curr = (int) this-&gt;fadingCurrentValue + this-&gt;fadingStep;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;                    <span class="keywordflow">if</span> (curr &gt; this-&gt;pPort-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>() || curr &lt; 0)</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;                        endStateAsc = <span class="keyword">true</span>;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;                    <span class="keywordflow">else</span></div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;                    {</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;                        this-&gt;LightFadingRaw((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>)curr);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;                        this-&gt;startingMillis = millis();</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;                    }</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;                }</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;                <span class="comment">//else</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;                    <span class="comment">//Serial.println(&quot;Fading delay not finished&quot;);</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            <span class="keywordflow">if</span> (endStateAsc)</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            {</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;                <span class="comment">// End of fading</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;                this-&gt;currentState = LIGHT_ON;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;                <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessoryBaseLight.html#ac82a7a3b7ab0da4aefd959d03ba0ed4a">IsBlinking</a>())</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                    this-&gt;startingMillis = millis();</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;                    this-&gt;startingMillis = 0;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;                this-&gt;LightOnRaw();</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            }</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        }</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        <span class="keywordflow">case</span> LIGHT_DESCENDING:</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        {</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            <span class="keywordtype">bool</span> endStateDesc = <span class="keyword">false</span>;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            <span class="keywordflow">if</span> (this-&gt;fadingStep == 0)</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;                endStateDesc = <span class="keyword">true</span>;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;                <span class="keywordflow">if</span> (millis() - this-&gt;startingMillis &gt; this-&gt;fadingDelay)</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;                {</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;                    <span class="keywordtype">int</span> curr = (int) this-&gt;fadingCurrentValue - this-&gt;fadingStep;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;                    <span class="keywordflow">if</span> (curr &lt;= 0)</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;                        endStateDesc = <span class="keyword">true</span>;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;                    <span class="keywordflow">else</span></div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;                    {</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;                        this-&gt;LightFadingRaw((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>)curr);</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;                        this-&gt;startingMillis = millis();</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                    }</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;                }</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                <span class="comment">//else</span></div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;                    <span class="comment">//Serial.println(&quot;Fading delay not finished&quot;);</span></div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            <span class="keywordflow">if</span> (endStateDesc)</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;            {</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;                <span class="comment">// End of fading</span></div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;                this-&gt;currentState = LIGHT_OFF;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;                <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessoryBaseLight.html#ac82a7a3b7ab0da4aefd959d03ba0ed4a">IsBlinking</a>())</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;                    this-&gt;startingMillis = millis();</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;                    this-&gt;startingMillis = 0;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;                this-&gt;LightOffRaw();</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;            }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        }</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    }</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;}</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="keywordtype">int</span> AccessoryBaseLight::EEPROMSave(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate)</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;{</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keywordflow">if</span> (!inSimulate)</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        EEPROM.write(inPos, this-&gt;state);</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <span class="keywordflow">return</span> inPos + 1;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;}</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="keywordtype">int</span> AccessoryBaseLight::EEPROMLoad(<span class="keywordtype">int</span> inPos)</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;{</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    this-&gt;state = (ACC_STATE)EEPROM.read(inPos++);</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;}</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;<span class="keywordtype">void</span> AccessoryBaseLight::printAccessory()</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;{</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Fading Step: &quot;</span>));</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    Serial.print(this-&gt;fadingStep);</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Fading Delay: &quot;</span>));</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    Serial.print(this-&gt;fadingDelay);</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / Blinking Delay: &quot;</span>));</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    Serial.print(this-&gt;blinkingDelay);</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; / &quot;</span>));</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessoryBaseLight.html#a1f57b9cf4b45b9bdc91fef927199b79c">GetPort</a>() != NULL)</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        this-&gt;<a class="code" href="classAccessoryBaseLight.html#a1f57b9cf4b45b9bdc91fef927199b79c">GetPort</a>()-&gt;printPort();</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    Serial.println(F(<span class="stringliteral">&quot; &quot;</span>));</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;}</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classAccessoryBaseLight_html_a1f57b9cf4b45b9bdc91fef927199b79c"><div class="ttname"><a href="classAccessoryBaseLight.html#a1f57b9cf4b45b9bdc91fef927199b79c">AccessoryBaseLight::GetPort</a></div><div class="ttdeci">Port * GetPort() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8hpp_source.html#l00061">AccessoryBaseLight.hpp:61</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_ac82a7a3b7ab0da4aefd959d03ba0ed4a"><div class="ttname"><a href="classAccessoryBaseLight.html#ac82a7a3b7ab0da4aefd959d03ba0ed4a">AccessoryBaseLight::IsBlinking</a></div><div class="ttdeci">bool IsBlinking() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8hpp_source.html#l00069">AccessoryBaseLight.hpp:69</a></div></div>
<div class="ttc" id="classAccessory_html_a3de65543a892b3418df72f54439605cb"><div class="ttname"><a href="classAccessory.html#a3de65543a892b3418df72f54439605cb">Accessory::ResetAction</a></div><div class="ttdeci">virtual void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00385">Accessory.hpp:385</a></div></div>
<div class="ttc" id="classAccessory_html_ae8c3ad3e37a2ba5914f419abd3e2426f"><div class="ttname"><a href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">Accessory::IsActionDelayPending</a></div><div class="ttdeci">bool IsActionDelayPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00398">Accessory.hpp:398</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_aa3b580656c99a87a7e88946f407e712d"><div class="ttname"><a href="classAccessoryBaseLight.html#aa3b580656c99a87a7e88946f407e712d">AccessoryBaseLight::IsFading</a></div><div class="ttdeci">bool IsFading() const </div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8hpp_source.html#l00074">AccessoryBaseLight.hpp:74</a></div></div>
<div class="ttc" id="classPort_html_a63cfeea67bec1eab18758d74cd435c00"><div class="ttname"><a href="classPort.html#a63cfeea67bec1eab18758d74cd435c00">Port::MoveStop</a></div><div class="ttdeci">virtual void MoveStop()</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00167">Port.hpp:167</a></div></div>
<div class="ttc" id="classPort_html_aed93eb0b1e3fcb88843f6c5606d55621"><div class="ttname"><a href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">Port::GetSpeed</a></div><div class="ttdeci">int GetSpeed() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00119">Port.hpp:119</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_accc565a1d92ad5f4fb05850f1390791b"><div class="ttname"><a href="classAccessoryBaseLight.html#accc565a1d92ad5f4fb05850f1390791b">AccessoryBaseLight::Event</a></div><div class="ttdeci">void Event(ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8cpp_source.html#l00120">AccessoryBaseLight.cpp:120</a></div></div>
<div class="ttc" id="classPort_html_aef667cb477268c60f098300e139530ba"><div class="ttname"><a href="classPort.html#aef667cb477268c60f098300e139530ba">Port::MoveLeftDir</a></div><div class="ttdeci">virtual void MoveLeftDir(unsigned long inDuration = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00143">Port.hpp:143</a></div></div>
<div class="ttc" id="classPort_html_a676359ed59bf5091126fd96e1a04cafa"><div class="ttname"><a href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">Port::SetSpeed</a></div><div class="ttdeci">virtual int SetSpeed(int inSpeed)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00108">Port.cpp:108</a></div></div>
<div class="ttc" id="classPort_html"><div class="ttname"><a href="classPort.html">Port</a></div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00061">Port.hpp:61</a></div></div>
<div class="ttc" id="classPort_html_a99e8526fed0e88d9f553767ef30860df"><div class="ttname"><a href="classPort.html#a99e8526fed0e88d9f553767ef30860df">Port::GetPinType</a></div><div class="ttdeci">PIN_TYPE GetPinType() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00110">Port.hpp:110</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_a1e1a200e6f6e47e63d07059c91265a91"><div class="ttname"><a href="classAccessoryBaseLight.html#a1e1a200e6f6e47e63d07059c91265a91">AccessoryBaseLight::SetFading</a></div><div class="ttdeci">void SetFading(uint8_t inStep, uint8_t inDelay)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8cpp_source.html#l00048">AccessoryBaseLight.cpp:48</a></div></div>
<div class="ttc" id="classAccessory_html_a60e5e9122c96773c975fe9d2c2db6520"><div class="ttname"><a href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">Accessory::SetStateRaw</a></div><div class="ttdeci">void SetStateRaw(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00165">Accessory.cpp:165</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_a88e2be8a90a47be58d0283ed8c6c973d"><div class="ttname"><a href="classAccessoryBaseLight.html#a88e2be8a90a47be58d0283ed8c6c973d">AccessoryBaseLight::AccessoryBaseLight</a></div><div class="ttdeci">AccessoryBaseLight(Accessory *inpOwner = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8cpp_source.html#l00015">AccessoryBaseLight.cpp:15</a></div></div>
<div class="ttc" id="classAccessoryBaseLight_html_a26c343fd849b47aea637ef7f34c3270a"><div class="ttname"><a href="classAccessoryBaseLight.html#a26c343fd849b47aea637ef7f34c3270a">AccessoryBaseLight::begin</a></div><div class="ttdeci">void begin(Port *inpPort, int inIntensity = 255, Accessory *inpOwner = 0)</div><div class="ttdef"><b>Definition:</b> <a href="AccessoryBaseLight_8cpp_source.html#l00062">AccessoryBaseLight.cpp:62</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>AccessoryBaseLight.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
